## Upsert Vectors `client.Vectorize.Indexes.Upsert(ctx, indexName, params) (*IndexUpsertResponse, error)` **post** `/accounts/{account_id}/vectorize/v2/indexes/{index_name}/upsert` Upserts vectors into the specified index, creating them if they do not exist and returns a mutation id corresponding to the vectors enqueued for upsertion. ### Parameters - `indexName string` - `params IndexUpsertParams` - `AccountID param.Field[string]` Path param: Identifier - `Body param.Field[Reader]` Body param: ndjson file containing vectors to upsert. - `UnparsableBehavior param.Field[IndexUpsertParamsUnparsableBehavior]` Query param: Behavior for ndjson parse failures. - `const IndexUpsertParamsUnparsableBehaviorError IndexUpsertParamsUnparsableBehavior = "error"` - `const IndexUpsertParamsUnparsableBehaviorDiscard IndexUpsertParamsUnparsableBehavior = "discard"` ### Returns - `type IndexUpsertResponse struct{…}` - `MutationID string` The unique identifier for the async mutation operation containing the changeset. ### Example ```go package main import ( "bytes" "context" "fmt" "io" "github.com/cloudflare/cloudflare-go" "github.com/cloudflare/cloudflare-go/option" "github.com/cloudflare/cloudflare-go/vectorize" ) func main() { client := cloudflare.NewClient( option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"), ) response, err := client.Vectorize.Indexes.Upsert( context.TODO(), "example-index", vectorize.IndexUpsertParams{ AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"), Body: io.Reader(bytes.NewBuffer([]byte("Example data"))), }, ) if err != nil { panic(err.Error()) } fmt.Printf("%+v\n", response.MutationID) } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "result": { "mutationId": "0000aaaa-11bb-22cc-33dd-444444eeeeee" }, "success": true } ```